# Class: YARD::Handlers::Ruby::ConstantHandler

Inherits:
  Base
  - Object
  - Base
  - Base
  - YARD::Handlers::Ruby::ConstantHandler
  show all

Includes:
  StructHandlerMethods

Defined in:
  lib/yard/handlers/ruby/constant_handler.rb

## Overview

Handles any constant assignment

## Constant Summary

### Constants included from CodeObjects

CodeObjects::BUILTIN_ALL, CodeObjects::BUILTIN_CLASSES, CodeObjects::BUILTIN_EXCEPTIONS, CodeObjects::BUILTIN_EXCEPTIONS_HASH, CodeObjects::BUILTIN_MODULES, CodeObjects::CONSTANTMATCH, CodeObjects::CONSTANTSTART, CodeObjects::CSEP, CodeObjects::CSEPQ, CodeObjects::ISEP, CodeObjects::ISEPQ, CodeObjects::METHODMATCH, CodeObjects::METHODNAMEMATCH, CodeObjects::NAMESPACEMATCH, CodeObjects::NSEP, CodeObjects::NSEPQ

## Instance Method Summary collapse

- #process ⇒ void

  Main processing callback.

### Methods included from StructHandlerMethods

#add_reader_tags, #add_writer_tags, #create_attributes, #create_class, #create_member_method?, #create_reader, #create_writer, #member_tag_for_member, #members_from_tags, #return_type_from_tag

### Methods included from CodeObjects::NamespaceMapper

#clear_separators, #default_separator, on_invalidate, #register_separator, #separators, #separators_for_type, #separators_match, #types_for_separator, #unregister_separator_by_type

### Methods included from Parser::Ruby

#s

## Constructor Details

This class inherits a constructor from YARD::Handlers::Base

## Instance Method Details

### #process ⇒ `void`

This method returns an undefined value.

Main processing callback

    8
    9
    10
    11
    12
    13
    14
    15
    16
    17
    18
    19
    20

    # File 'lib/yard/handlers/ruby/constant_handler.rb', line 8

    process do
      if statement[1].call? && statement[1][0][0] == s(:const, "Struct") &&
         statement[1][2] == s(:ident, "new")
        process_structclass(statement)
      elsif statement[1].call? && statement[1][0][0] == s(:const, "Data") &&
         statement[1][2] == s(:ident, "define")
        process_dataclass(statement)
      elsif statement[0].type == :var_field && statement[0][0].type == :const
        process_constant(statement)
      elsif statement[0].type == :const_path_field
        process_constant(statement)
      end
    end